/***************************************************
*  Copyright (c) 2009. All rights reserved.
*  Posession or use of this file requires a written 
*  license from the author.
*  
*  Author:  iThinker
*  Created: 2009-2-23
***************************************************/
#ifndef _H_CLASSIFIER_DLL
#define _H_CLASSIFIER_DLL

#include <string>
using namespace std;
#ifndef OS_LINUX
#pragma warning(disable:4786)
#endif

#ifdef OS_LINUX
#define CLASSIFIER_API  extern "C"
#else
#ifdef LJCLASSIFIER_EXPORTS
#define CLASSIFIER_API extern "C" __declspec(dllexport)
#else
#define CLASSIFIER_API extern "C"  __declspec(dllimport)
#endif
#endif


typedef struct _stDoc {
	string sTitle;
	string sContent;
	string sAuthor;
	string sBoard;
	string sDatatype;
}stDoc;


// ܣ  ݿתļ
// ֵɹ/ʧ  
//         Ϣ¼Ӳ̵./ljclassifier.log
CLASSIFIER_API bool classifier_db_ruleread(const char *dbconf="config.ini");

// ܣ  ļʽʼ
// ֵɹ/ʧ  
//         Ϣ¼Ӳ̵./ljclassifier.log./DataFile/ljclassifier.log
CLASSIFIER_API bool classifier_init(const char *conf="rulelist.xml",const char *sInitDirPath="");

// ܣ½ṹз
// d:½ṹָ
//       iType=0:  ֮\t  ݸʽҪ		ϡ
//       iType=1:  Ŷȣ֮\tȨá    ݸʽҪ 1.00	 0.95	 0.82
//       iType ĬֵΪ0
// ֵ  ֮\tŶȴӸߵ      
CLASSIFIER_API const char* classifier_exec1(stDoc& d, int iType=0);
CLASSIFIER_API const char* classifier_exec(const char* sTitle,const char*sContent, int iType);
// ܣڵǰĵȡýϸ
// classname:
// ֵϸ :
/*		   RULE3:
		   SUBRULE1: Ļ 1	
		   SUBRULE2:  1	 3	Ʊ 8	
		   SUBRULE3: ժ 2	*/
CLASSIFIER_API const char* classifier_detail(const char *classname);

// ܣ˳ͷԴ
CLASSIFIER_API void classifier_exit();

CLASSIFIER_API void classifier_setsimthresh(float fSim);


#endif //_H_CLASSIFIER_DLL

